// Cg_Shader.h: Schnittstelle fr die Klasse Cg_Shader
//
//////////////////////////////////////////////////////////////////////

#ifndef CG_SHADER_H
#define CG_SHADER_H


#include <Cg/cg.h>
#include <Cg/cgGL.h>

//#define WIN32_LEAN_AND_MEAN
//#include <windows.h>

#include <GL/gl.h>
#include <GL/glext.h>


// methods

void cgErrorCallback();
void InitializeCgFragment(char* fragmentShader, CGcontext& context, CGprofile& fragmentProfile, CGprogram &fragmentProgram);
void InitializeCgVertex(char* vertexShader, CGcontext& context, CGprofile& vertexProfile, CGprogram &vertexProgram);
void InitializeCg(char* vertexShader, char* fragmentShader, CGcontext& context, CGprofile& vertexProfile, CGprofile& fragmentProfile, CGprogram& vertexProgram, CGprogram& fragmentProgram);

/* initialize the function pointers to their implementation */
void InitializeExtensions();





// fields

/*
    Function pointer for specifying multitexture coordinates on the
    first multitexture unit.

    The commands glMultiTexCoordifARB map to the well-known glTexCoordif, 
    specifying i-dimensional texture-coordinates. These can substitute the 
    glTexCoordif functions. 
*/
extern PFNGLMULTITEXCOORD1FARBPROC glMultiTexCoord1fARB;

/*
    Function pointer for specifying multitexture coordinates on the
    second multitexture unit.

    The commands glMultiTexCoordifARB map to the well-known glTexCoordif, 
    specifying i-dimensional texture-coordinates. These can substitute the 
    glTexCoordif functions. 
*/
extern PFNGLMULTITEXCOORD2FARBPROC glMultiTexCoord2fARB;

/*
    Function pointer for specifying multitexture coordinates on the
    third multitexture unit.

    The commands glMultiTexCoordifARB map to the well-known glTexCoordif, 
    specifying i-dimensional texture-coordinates. These can substitute the 
    glTexCoordif functions. 
*/
extern PFNGLMULTITEXCOORD3FARBPROC glMultiTexCoord3fARB;

/*
    In order to build a 3D texture, we need this extension.
*/
extern PFNGLTEXIMAGE3DPROC glTexImage3D;

/*
    Function pointer for specifying multitexture coordinates on the
    fourth multitexture unit

    The commands glMultiTexCoordifARB map to the well-known glTexCoordif, 
    specifying i-dimensional texture-coordinates. These can substitute the 
    glTexCoordif functions. 
*/
extern PFNGLMULTITEXCOORD4FARBPROC glMultiTexCoord4fARB;

/* function pointer for selecting the active multitexture unit */
extern PFNGLACTIVETEXTUREARBPROC glActiveTextureARB;

/* function pointer for selecting the active multitexture coordinate array */
extern PFNGLCLIENTACTIVETEXTUREARBPROC glClientActiveTextureARB;

/* function pointer for setting the secondary color */
extern PFNGLSECONDARYCOLOR3FEXTPROC glSecondaryColor3fEXT;

/* function pointer for setting the secondary color */
extern PFNGLSECONDARYCOLOR3FVEXTPROC glSecondaryColor3fvEXT;





#endif